;**********************************************************************************
;	PIC16F690	16Mhz   TMR0   LCD
;                      
;**********************************************************************************
	list	p = 16f690, st=off, w=2
	;list	r=decimal			  				 ; default number base
	#include "p16f690.inc"           ;    MPLAB
            __CONFIG  30C4h       ;   : ,
                                   ; .
;==================================================================================
;==================================================================================
;     . 
;==================================================================================
W_copy		EQU	070h			;     
ST_copy		EQU	071h			;  
FSR_copy	EQU	072h
PCLATH_copy	EQU	073h
;ALARM		equ	074h    	    ; 
FLAGS	    equ 078h         ;               
WPU_A     equ        79h         ; 
;......     equ        7Ah         ; 
;......     equ        7Bh         ; 
;......     equ        7Ch         ; 
;......     equ        7Dh         ;    
;......     equ        7Eh         ;     
;......     equ        7Fh         ;  
;==================================================================================
;  
;==================================================================================
#DEFINE		F_Tmr1			FLAGS,0		; 
#DEFINE		F_Het_Er			FLAGS,1		;
#DEFINE		F_Down_T			FLAGS,2		; .
#DEFINE		F_UP_T				FLAGS,3		; .

#DEFINE		Q_Fan		PORT_B,7	;  
#DEFINE		Q_heat		PORT_C,5	;  
#DEFINE		Q_SleepRes		PORT_C,4	; 
#DEFINE		Q_STEP			WPU_A,4		; .  0.2
#DEFINE		Q_DIR			WPU_A,5		; .  0.2
#DEFINE		Q2_STEP			WPU_A,2

#DEFINE 	lcd_rs 		PORT_A,0
#DEFINE 	lcd_e 	 	PORT_A,1


;==================================================================================
; 
;==================================================================================
;C_h_H	equ	00h
;C_h_L	equ	01h


;==================================================================================
;       .
;==================================================================================
PORT_C      	equ        21h         ;
PORT_A        	equ        23h         ;
PORT_B      	equ        24h         ;
counter	    	equ        025h    	  ;   
;----- VARIABLES HD44780------------------------------------------------------------------------------
multiplier	equ			0x26	;   temp1  temp2
temp1		equ			0x26	; multiplier+0	   
temp2		equ 		0x27	; multiplier+1
temp3		equ 		0x28
Temp		equ		 	0x29
;-----
;Seting_temp	equ			0x2A	;     
;R_kr60		equ			0x2B
;''''''''''''''''''''''''''''
;		equ		0x2C

;		equ		0x2F
;''''''''''''''''''''''''''''
;............................
;R_minut		equ			0x40
t1_4_sec	equ			0x41
Het_Er		equ			0x42
R_mlsec		equ			0x43
;FlagM_LCD	equ			0x44
;''''''''''''''''''''''''''''
div_result	equ			0x45
work_data		equ		0x46	;|\
;work_data+1	equ		0x47	;| \
;work_data+2	equ		0x48	;| / 4 bayt
;work_data+3	equ		0x49	;|/
product			equ		0x4A	; +0,+1  +2   ,   
TISYACH			equ		0x4A	; product+0
SOTNI			equ		0x4B	; product+1
DESYATK			equ		0x4C	; product+2
EDINIC			equ		0x4D
DTISYACH		equ		0x4E

izmerL_Rt			equ		0x4F	;\
izmerH_Rt			equ		0x50	;/ 
;TemperL			equ		0x51	;\
;TemperH			equ		0x52	;/
izmerL_T	 		equ		0x53	;
izmerH_T	 		equ		0x54	;/.
izmerH_Rs		equ		0x55	;  
pwm_speed		equ		0x56	; ..   .
desytka			equ		0x57
izmerL_U		equ		0x58
izmerH_U		equ		0x59	;\

;		equ		0x5E
;-----------------------------------------------------------------
; ,        .
;-----------------------------------------------------------------
   
;===============================================================================================
;   .
;===============================================================================================
RP0         equ        5           ;   .
RP1         equ        6           ;   .
Z           equ        2           ;  
;===============================================================================================
;                         ---  ---
BANK0	MACRO
	BCF STATUS,RP0
	BCF STATUS,RP1
	endm
BANK1	MACRO
	BSF STATUS,RP0
	BCF STATUS,RP1
	endm
BANK2	MACRO
	BCF STATUS,RP0
	BSF STATUS,RP1
	endm
;BANK3	MACRO
;	BSF STATUS,RP0
;	BSF STATUS,RP1
;	endm
mov     MACRO   DEST1,SOURCE1      ;  -
	movf    SOURCE1,W
	movwf   DEST1
	endm
mvi     MACRO   DEST2,CONST2       ;    
	movlw   CONST2
	movwf   DEST2
	endm
;subl    MACRO   CONST3,DEST3       ;    
;	movf	DEST3,w
;	sublw   CONST3
;	endm
;subw    MACRO   DELM6,DEST6       ;    
;	movf	DEST6,w
;	subwf   DELM6,w
;	endm

;===============================================================================================
            org        0           ;    

			GOTO       Init        ;  
;    
            org        4           ;  ...
;***********************************************************************************************
;			  
;***********************************************************************************************
;----     -------
Interrupt	movwf	W_copy		; 
			mov		ST_copy,STATUS
			mov		FSR_copy,FSR
			mov		PCLATH_copy,PCLATH
			BANK0				; 0 
	bcf 	PCLATH,3 		;  0
;---------------------------------------------

I_TMR1
			btfss	PIR1,TMR1IF
			goto	I_TMR0
				movlw	-(.195)		;
				ADDWF	TMR1H,f		; 
			BCF		PIR1,TMR1IF		;    
			bsf		F_Tmr1
			incf	t1_4_sec,f

I_TMR0
		 	btfss	INTCON,T0IE		;on/off TMR0
 			goto	push_
			btfss	INTCON,T0IF		;  TMR0
			goto	push_
				movf	pwm_speed,w	;
				ADDWF	TMR0,f		; 
				bcf		INTCON,T0IF	; TMR0
			btfss	Q_STEP
			goto	$+4
			bcf		Q_STEP
			bcf		Q2_STEP
			goto	push_
			bsf		Q_STEP
			bsf		Q2_STEP
			goto	push_

;----     --------
push_
	BANK1
		mov	WPUA,WPU_A
	BANK0
		mov	PORTB,PORT_B
		mov	PORTA,PORT_A
		mov	PORTC,PORT_C

		mov		PCLATH,PCLATH_copy
		mov		FSR,FSR_copy
		mov		STATUS,ST_copy		; 
		swapf	W_copy,F		;  ,    Z  STATUS
		swapf	W_copy,W		;(movf   ,  swapf - )
		retfie				;      GIE

;***********************************************************************************************
;***********************************************************************************************
;		   hex,dec  ASCII 
;***********************************************************************************************
Decode_HexDec_ASCII
		clrf	PCLATH
		andlw	b'00001111'		; 15
 		addwf	PCL,F		 	; 

    dt		"0123456789"
	dt		"ABCDEF"		;    
        ;       wreg  
;***********************************************************************************************
;		 
;***********************************************************************************************
Imit_vracheniya
		clrf	PCLATH
		andlw	b'00000111'		; 
 		addwf	PCL,F		 	; 

		retlw '/'
		retlw '/'
		retlw '-'
		retlw '-'
		retlw '|'
		retlw '|'
		retlw '-'
		retlw '-'

;***********************************************************************************************
;***********************************************************************************************
;                                       
;***********************************************************************************************
;  
;===============================================================================================
Init

		movlw	b'00000000'
		movwf	PORTC
		movwf	PORT_C

		clrf		PORTB
		clrf		PORT_B
		movlw		b'00000000'
		movwf		PORTA
		movwf		PORT_A

				movlw	.10			; ...
				call	READ_EE	
				andlw b'00000111'
			BANK1
				IORLW B'00000000'	;WDT (17ms - 2.3s)
		;			    ||||||||      ;  (. ) OPTION_REG
		;			    |||||||+-- "0" -  000
		;			    ||||||+--- "0" -  
		;			    |||||+---- "1" -   TMR0=2,4,8,16,32,64,128,256
		;			    ||||+----- "0" -   TMR0
		;			    |||+------ "0" -      TMR0
		;			    ||+------- "0" -     TMR0
		;			    |+-------- "1" -      INT
		;			    +--------- "1" -    1
				movwf	OPTION_REG
            MOVLW      b'11000000' ; 
            MOVWF      TRISC	   ;
            MOVLW      b'01110000' ; 
            MOVWF      TRISB	   ; Configure PORTB
            MOVLW      b'11111100' ;
            MOVWF      TRISA	   ; Configure PORTA

		clrf	IOCA			;  
		clrf	WPU_A
		clrf	WPUA		; .
		clrf	PIE1			; 
		clrf	PIE2			; 
		clrf	ADCON1
			mvi	WDTCON,B'00010111'	;WDT (   1 ms  268 )
		;			     ||||||||      ;  (. ) OPTION_REG
		;			     |||||||+-- "0" - 0 = WDT  (  )
		;			     ||||||+--- "0" -   1001=1:16384(~0,5s), 1011 = 1:65536(~2s)
		;			     |||||+---- "0" -  
		;			     ||||+----- "0" -   0100=1:512 (   17ms)
		;			     |||+------ "0" -   1000=1:8192 (~0.25s)
		;			     ||+-------
		;			     |+-------- 
		;			     +--------- 
			mvi	OSCCON,B'01100000'	;  
		;			     ||||||||      ; 
		;			     |||||||+-- "0" - SCS:      1 = 
		;			     ||||||+--- "0" - LTS:   LFINTOSC (   31 kHz)
		;			     |||||+---- "0" - HTS:   HFINTOSC (    8 MHz  125 kHz)
		;			     ||||+----- "0" - OSTS: (1)     
		;			     |||+------ 111 = 8MHz	101 = 2MHz	100 = 1MHz
		;			     ||+-------	110 = 4 MHz ( )
		;			     |+-------- 011 = 500 kHz	010 = 250 kHz	001 = 125 kHz	000 = 31 kHz (LFINTOSC)
		;			     +--------- 
		BANK2
        clrf    VRCON       ;    .
		clrf	ANSEL			;  
		clrf	ANSELH			;  
		clrf	IOCB			;  
		clrf	WPUB			; .
		clrf	CM1CON0			;
		clrf	CM2CON0
		clrf	CM2CON1
		BANK0				  ;  0- 
		clrf	PIR1			; 
		clrf	PIR2			; 
		clrf	ADCON0

            clrf       T1CON       ; ----"----  TMR1.
            clrf       T2CON       ; ----"----  TMR2.
            clrf       CCP1CON     ; ----"----  CCP.

			mvi	INTCON,B'11000000'
		;				 ||||||||      ;  (. ) INTCON
		;				 |||||||+-- "0" -      =RABIF
		;				 ||||||+--- "0" -    INT/RB2 = INTF
		;				 |||||+---- "0" -    TMR0 = T0IF
		;				 ||||+----- "1" -      =RABIE
		;				 |||+------ "0" -   = INTE
		;				 ||+------- "0" -   TMR0 = T0IE
		;				 |+-------- "1" -      = PEIE
		;				 +--------- "1" -    = GIE

		call	init_ACP
		call	START_TMR1
		call	LCD_INIT
		call	init_encoder
	;	call	Init_PWM
;	-- 
	call	#Upit_PICa
	;btfss	STATUS,3		; =0   sleep ?
	btfss	STATUS,4		; =0   WDT ?
		goto	MAIN
	clrf	izmerL_Rt	
	clrf	izmerH_Rt	
	clrf	izmerL_T	
	clrf	izmerH_T
	clrf	izmerL_U	
	clrf	izmerH_U	
	clrf	izmerH_Rs	
	clrf	pwm_speed
	mvi	Het_Er,.1
	clrf	FLAGS

;***********************************************************************************************
;                                       
;***********************************************************************************************
MAIN
CLRWDT

		btfss	F_Tmr1		;
		goto	MAIN
		bcf		F_Tmr1
M_02
;   1   0,2
		call	izmer_tC
		call	izmer_Rt
		call	izmer_Rspeed
		call	izmer_Ui
		call	Heat_Error
		call	Sravn_izm_zad_T
		call	ON_Off_speed
		call	ON_Off_Fan
		call	LCD	

goto MAIN

;***********************************************************************************************
;                                      LCD
;***********************************************************************************************
LCD
	goto	Menu_0

	return
;***********************************************************************************************
;                                         
;***********************************************************************************************
izmer_Rspeed
	call	PUSK_ACP2
		btfsc	ADCON0,GO
		goto	$-1
				movlw	4			; ..
				call	READ_EE		;
			btfsc	STATUS,Z
			goto	izmer_Rs_002
		comf	ADRESH,w
		addwf	izmerH_Rs,f
		rrf		izmerH_Rs,f
		;mov		izmerH_Rs,ADRESH
	return
izmer_Rs_002
		movf	ADRESH,w
		addwf	izmerH_Rs,f
		rrf		izmerH_Rs,f
		;mov		izmerH_Rs,ADRESH
	return
;***********************************************************************************************
;                                      
;***********************************************************************************************
ON_Off_speed

			movf	izmerH_Rs,w	
				movlw	2			; ..
				call	READ_EE		;
			subwf	izmerH_Rs,w		; 
			btfss	STATUS,C	;  C=0	;.   C=1
		goto	Off_speed
	;			movlw	3		;  .
	;			call	READ_EE
	;		subwf	izmerH_Rs,w		; 
	;		btfsc	STATUS,C	;  C=0	;.   C=1
	;	goto	Off_speed
On_speed
		mov		Temp,pwm_speed	;  ..   
				movlw	2			; ..
				call	READ_EE		;
		subwf	izmerH_Rs,w		; .,       tmr0        .
		addwf	Temp,f
		rrf		Temp,w
		movwf	pwm_speed
		bcf		INTCON,T0IF		; TMR0
		bsf		INTCON,T0IE		;on/off TMR0
		bsf		Q_SleepRes
	return
Off_speed
		clrc
		rrf		pwm_speed,f		; 
		movf	pwm_speed,w
		btfss	STATUS,Z
	return
		bcf		INTCON,T0IE		;on/off TMR0
	;	bcf		Q_STEP
		bcf		Q_SleepRes
	return
;***********************************************************************************************
;                                         12v
;***********************************************************************************************
izmer_Ui
	call	PUSK_ACP3
		btfsc	ADCON0,GO
		goto	$-1
		BANK1
		movf	ADRESL,w
		BANK0
  		movwf	work_data+0	
		mov		work_data+1,ADRESH
		clrf	work_data+2
		mov		product+0,izmerL_U
		mov		product+1,izmerH_U
			call	Add24_16
		mvi		Temp,.2
			call	Divide24_8U
		mov		izmerL_U,work_data+0
		mov		izmerH_U,work_data+1
	return
;***********************************************************************************************
;                                          
;***********************************************************************************************
izmer_Rt
	call	PUSK_ACP1
		btfsc	ADCON0,GO
		goto	$-1
	goto	izmer_Rt_max
	;	BANK1
	;	movf	ADRESL,w
	;	BANK0
  	;	movwf	izmerL_Rt
	;	mov		izmerH_Rt,ADRESH

;***********************************************************************************************
;                                           
;***********************************************************************************************
izmer_Rt_filtr
		mov		product+0,izmerL_Rt
		mov		product+1,izmerH_Rt	
			call	Add24_16
		mvi		Temp,.2
			call	Divide24_8U
	return
;***********************************************************************************************
;                                       .     
;***********************************************************************************************
izmer_Rt_max
		BANK1
		movf	ADRESL,w
		BANK0
  		movwf	work_data+0	
		mov		work_data+1,ADRESH
		clrf	work_data+2
;----  ..    
		mvi		product+0,.60	;
		clrf	product+1		; .   
		call	Sub16
		btfss   STATUS,C 		;=1  work_data>=product ;=0  work_data<product
		goto	otricat_rez
;----      ~170  ~270,   2  +310
		BANK1
		movf	ADRESL,w
		BANK0
  		movwf	work_data+0	
		mov		work_data+1,ADRESH
		clrf	work_data+2
;---->
			clrc
			rrf	work_data+1,f	;  2
			rrf	work_data+0,f
			mvi		product+0,036h
			mvi		product+1,001h
			call	Add24_16
	call	izmer_Rt_filtr
  		mov		izmerL_Rt,work_data+0
		mov		izmerH_Rt,work_data+1
	return

otricat_rez
		clrf	izmerL_Rt
		clrf	izmerH_Rt
		bcf		F_Het_Er	;  
	return


  	;	mov		work_data+0,izmerL_Rt
	;	mov		work_data+1,izmerH_Rt
	;	clrf	work_data+2
	;		movlw	1
	;		call	READ_EE	
	;	movwf	product+0			;=xx
	;	mvi		product+1,.3		;3*256+xx=  .   
	;	call	Sub16
	;		movlw	1
	;		call	READ_EE	
	;	btfsc   STATUS,C 		;=1  work_data>=product ;=0  work_data<product
	;	movwf	izmerL_Rt		; 
	return

;***********************************************************************************************
;                                         
;***********************************************************************************************
izmer_tC
	call	PUSK_ACP0
		btfsc	ADCON0,GO
		goto	$-1
	call	T_dinamica
		BANK1
		movf	ADRESL,w
		BANK0
  		movwf	izmerL_T
		mov		izmerH_T,ADRESH
	return
;***********************************************************************************************
;                                         
;***********************************************************************************************
T_dinamica
		BANK1
		movf	ADRESL,w
		BANK0
  		subwf	izmerL_T,w
		btfss	STATUS,Z
		goto	T_d_002
		movf	ADRESH,w
  		subwf	izmerH_T
		btfss	STATUS,Z	;  =0 
		goto	T_d_002
		bcf		F_UP_T
		bcf		F_Down_T
	return
T_d_002
		BANK1
		movf	ADRESL,w
		BANK0
  		movwf	work_data+0
		mov		work_data+1,ADRESH
		clrf	work_data+2
		mov		product+0,izmerL_T	;
		mov		product+1,izmerH_T
		call	Sub16
		bcf		F_UP_T
		btfsc   STATUS,C 		;=1  work_data>=product ;=0  work_data<product
		bsf		F_UP_T
		bcf		F_Down_T
		btfss   STATUS,C 		;=1  work_data>=product ;=0  work_data<product
		bsf		F_Down_T
	
	return

;***********************************************************************************************
;                                          .
;***********************************************************************************************
Sravn_izm_zad_T
;-------    
		mov		work_data+0,izmerL_T	;
		mov		work_data+1,izmerH_T
		clrf	work_data+2
		mvi		product+0,.255	;  t  ,
		clrf	product+1
			call	Add24_16		;
		mov		product+0,izmerL_Rt	;
		mov		product+1,izmerH_Rt
			call	Sub16
		btfss   STATUS,C 		;=1  work_data>=product ;=0  work_data<product
			goto	ON_heat		; Tizm+delta<Tzad

		btfss   F_UP_T
	goto	ht_002
;-------    
		mov		work_data+0,izmerL_T	;
		mov		work_data+1,izmerH_T
		clrf	work_data+2
			movlw	6		;   t  , ..    
			call	READ_EE
		movwf	product+0	;
		clrf	product+1
			call	Add24_16		;
		mov		product+0,izmerL_Rt	;
		mov		product+1,izmerH_Rt
			call	Sub16
		btfss   STATUS,C 		;=1  work_data>=product ;=0  work_data<product
			goto	ON_heat		; Tizm+delta<Tzad
 			goto	Off_heat	; Tizm+delta>=Tzad
	return

ht_002
		btfss   F_Down_T
	return
;-------  .  
		mov		work_data+0,izmerL_T	;
		mov		work_data+1,izmerH_T
		clrf	work_data+2
			movlw	5		;   t  , ..  .  
			call	READ_EE
		movwf	product+0	;
		clrf	product+1
			call	Sub16
		mov		product+0,izmerL_Rt	;
		mov		product+1,izmerH_Rt
			call	Sub16
		btfss   STATUS,C 		;=1  work_data>=product ;=0  work_data<product
			goto	ON_heat		; Tizm-delta<Tzad
 			goto	Off_heat	; Tizm-delta>=Tzad
	return
;***********************************************************************************************
;                                      . 
;***********************************************************************************************
ON_heat
		btfsc	F_Het_Er
 			goto	Off_heat
		bsf	Q_heat	;
		mov	PORTC,PORT_C
	return
Off_heat
		bcf	Q_heat
		mov	PORTC,PORT_C
	return
;***********************************************************************************************
;                                        
;***********************************************************************************************
Heat_Error
		btfss	Q_heat	
	goto	Heat_Er_002
		btfsc	F_UP_T
		decfsz	Het_Er,f	; 
		btfss	F_UP_T
		incf	Het_Er,f	; 
		movf	Het_Er,w
		sublw	.50			; 1
		btfsc	STATUS,C	;  C=0	;.   C=1
	return
		bsf		F_Het_Er
		goto	Off_heat
	return
Heat_Er_002
		mvi	Het_Er,.1
	return
;***********************************************************************************************
;                                      .  
;***********************************************************************************************
ON_Off_Fan
		mov		work_data+0,izmerL_T	
		mov		work_data+1,izmerH_T
		call	ACP_Temperat
			movwf	Temp
				movlw	.7			; . ./. 
				call	READ_EE		;
			subwf	Temp,w		;
			btfss	STATUS,C	;  C=0	;.   C=1
		bcf		Q_Fan
			btfsc	STATUS,C	;  C=0	;.   C=1
		bsf		Q_Fan
	return
;***********************************************************************************************
;***********************************************************************************************
;                                      
;***********************************************************************************************
init_encoder
			movlw	0		;
			call	READ_EE		;..
			bcf		Q_DIR
			btfss	STATUS,Z
			bsf		Q_DIR
	return
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;Menu_start
Menu_0
			movlw 0x80+0x00					; set LCD address (left char of first line)
			call lcd_send_instruction_w
		call	#izmer_tC
		call	#izmer_Rt
		call	#izmer_Rs

			movlw 0x80+0x40
			call lcd_send_instruction_w		; set address (left char of second line)

		btfsc	F_Het_Er
 			goto	#Het_Error

		call	#On_Of_hot
	;	goto	#Inp_R
		call	#On_Of_fan
		;call	#On_Of_Enc
		call	#izmer_Ui
return
;------

;--------------------------------------------------------------------------------
;  
Menu_20
return
;goto	 START

;===========     ====================================


#include	3Dpet_Formul690.inc
#include	3Dpet_AcpPwm.inc
#include 	3Dpet_hd44780_690.inc

;===========  EEPROM   ====================================
org 0x2100
	 de	.1	,		;0;   0/1
	 de	.70
	 de	.8			;2;   
	 de	.255		;3;   
	 de	.1	,		;4;    0/1
	 de	.3	,		;5;   t  , ..  .  
	 de	.4	,		;6;   t  , ..    
	 de	.70	,		;7; . ./. 
	 de	.36	,		;8;   U.
	 de	.100 ,		;9;   U.,  
	 de	.3 ,		;10;   (0...7) TMR0=2,4,8,16,32,64,128,256

org 0x2110

	 de .200



                end                     ;  .